clear all
close all
clc

MC=5e4;
K=1e3;       
MM=round(logspace(1,2,6));



psml_SA_mse=zeros(1,length(MM));
psml_2b_mse=zeros(1,length(MM) );
ml_mse=zeros(1,length(MM));
psml_68_mse=zeros(1,length(MM));
ml_y_mse=zeros(1,length(MM));
B=zeros(1,length(MM));

CS_mse=zeros(1,length(MM));
CS_bias=zeros(1,length(MM));
    
psml_SA_bias=zeros(1,length(MM));
psml_2b_bias=zeros(1,length(MM));
ml_bias=zeros(1,length(MM));
psml_68_bias=zeros(1,length(MM));
ml_y_bias=zeros(1,length(MM));
t_sa=zeros(1,length(MM));
t_68=zeros(1,length(MM));
t_2b=zeros(1,length(MM));
NN=[250,1e4];  
for n=1:length(NN)
    N=NN(n); 
    Nx=round(0.8*N);
    Ny=N-Nx;
    for k=1:length(MM) 
        M=MM(k);
        display(M)
        H=eye(M);
        C=toeplitz(1./((1:M)).^2);
        theta=ones(M,1);
    %     theta(2:3)=theta(2:3)+linspace(0.01,0.02,2)';
    %     theta(1)=1.05;
    %     theta(M)=0;
        Jx=Nx*H.'*(C\H);
        Jy=Ny*H.'*(C\H);
        J=Jx+Jy;
        A=((H'*(C\H))\H')*C^-1;
        CRBx=Jx^-1;
        CRBy=Jy^-1;
        CRB=J^-1;

        parfor l=1:MC
            wx=(mvnrnd(zeros(Nx,M),C))';
            x=repmat(H*theta,1,Nx)+wx;
            x_mean=mean(x,2);
            theta_ml_x=A*x_mean;
            [~,m]=max(theta_ml_x);
            %----
            wy=(mvnrnd(zeros(Ny,M),C))';
            y=repmat(H*theta,1,Ny)+wy;
            theta_ml_y=A*mean(y,2);
            theta_ml=(Nx/N)*theta_ml_x+(Ny/N)*theta_ml_y;

            %-------------2nd best
            tic
            temp=theta_ml_x;
            temp(m)=-inf;
            [~,m2]=max(temp);
            theta_2b_psml=psml_2best(CRB,CRBx,theta_ml,m,m2);
            t_2bl(l)=toc;

            %-----------------SA-PSML
            tic
            theta_SA68_psml=sa68_iterative(N,Jx,CRBx,CRB,theta_ml,m,K);
            t_l68(l)=toc;
            %-------------------------

        end
        t_68(n,k)=mean(t_l68);
        t_2b(n,k)=mean(t_2bl);
    end
end
    
%%
save(strcat('..\LCMEAS_mcode\simulations\',num2str(rand(1)),'MC=',num2str(MC),' Nx=',num2str(Nx),' Ny=',num2str(Ny),'SA_2b_psml_vs_M_2stages.mat'))
%%
LW=1.3;
fontsize=12;
figure(1)
loglog(MM,t_68(1,:),'--or','LineWidth',LW)
hold on
loglog(MM,t_2b(1,:),'--sg','LineWidth',LW)
hold on
loglog(MM,t_68(2,:),'--xb','LineWidth',LW)
hold on
loglog(MM,t_2b(2,:),'--*m','LineWidth',LW)

ylabel('Mean run-time [sec]')
xlabel('M')
legend(strcat('$\hat{\theta}^{(SA-PSML)}$',' N=',num2str(NN(1))),...
         strcat('$\hat{\theta}^{(2b-PSML)}$',' N=',num2str(NN(1))),...
         strcat('$\hat{\theta}^{(SA-PSML)}$',' N=',num2str(NN(2),'%.0e')),...
         strcat('$\hat{\theta}^{(2b-PSML)}$',' N=',num2str(NN(2),'%.0e')))
set(legend,'Interpreter','LaTex')
grid on
set(legend,'FontSize',fontsize)
set(gca,'fontsize',fontsize) 
ylim([min(min(t_2b)),1])
