clear all
close all
clc

% Comparison between the pairwise probability of selection 

M=25;
H=eye(M);   

C=toeplitz(1./((1:M)).^2);

theta=ones(M,1);
theta(2:3)=theta(2:3)+linspace(0.01,0.02,2)';
theta(1)=1.05;
theta(M)=0;
%K=logspace(1,3,5); % num of Monte Carlo for SA
MC=5e4;
A=((H'*(C\H))\H')*C^-1;      
NN=round(logspace(2,4,10));

% initializations
[~,m]=max(theta);
temp=theta;
temp(m)=-inf;
[~,m2]=max(temp);
I=eye(M);
mu=I(:,m)-I(:,m2);

 %-----------------------------------------
 
parfor n=1:length(NN) 
    N=NN(n); 
    display(N)
    Nx=round(0.8*N);
    Ny=N-Nx;
    Jx=Nx*H.'*(C\H);
    Jy=Ny*H.'*(C\H);
    J=Jx+Jy;
    CRB=inv(J);
    sigma=sqrt(mu'*(Jx\mu));
    del=(theta(m)-theta(m2))/sigma; 
    %--------------------
    p_tilde(n)=normcdf(del); % this is an analitical calaculation 
    %-------------------
    %p(n,:)=prob_est_lin_gauss(theta,CRB,m,K); % this is an empirical calaculation
    theta_ml_pseodo=(mvnrnd(theta,CRB,MC))';
    [~,mvec]=max(theta_ml_pseodo);
    p(n)=mean(mvec==m);

end
%%
save(strcat('..\LCMEAS_mcode\simulations\',num2str(rand(1)),' MC=',num2str(MC),' M=',num2str(M),'prob_comp_linGauss.mat'))
%%
LW=1.3;
fontsize=12;

semilogx(NN,p_tilde,'--sg','LineWidth',LW)
hold on
semilogx(NN,p,'--or','LineWidth',LW)

ylabel('Probability of selection')
xlabel('N')
legend('$\Pr(\tilde{\Psi}_x^{(m,\tilde{m})}=m)$','$\Pr(\Psi_x=m)$')

set(legend,'Interpreter','LaTex')
grid on
set(legend,'FontSize',fontsize)
set(gca,'fontsize',fontsize)